/*
 * noVNC: HTML5 VNC client
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * See README.md for usage and integration instructions.
 */
function Display(e){"use strict";function t(){Util.Debug(">> Display.constructor");var e,t,a,r,i=Util.Engine;if(!d.target)throw"target must be set";if("string"==typeof d.target)throw"target must be a DOM element";if(e=d.target,!e.getContext)throw"no getContext method";if(c||(c=e.getContext("2d")),Util.Debug("User Agent: "+navigator.userAgent),i.gecko&&Util.Debug("Browser: gecko "+i.gecko),i.webkit&&Util.Debug("Browser: webkit "+i.webkit),i.trident&&Util.Debug("Browser: trident "+i.trident),i.presto&&Util.Debug("Browser: presto "+i.presto),s.clear(),!("createImageData"in c))throw"Canvas does not support createImageData";for(d.render_mode="canvas rendering",null===d.prefer_js&&(Util.Info("Prefering javascript operations"),d.prefer_js=!0),m=c.createImageData(16,16),a=[],t=0;256>t;t+=1)a.push(255);try{r=e.style.cursor,changeCursor(d.target,a,a,2,2,8,8),e.style.cursor?(null===d.cursor_uri&&(d.cursor_uri=!0),Util.Info("Data URI scheme cursor supported")):(null===d.cursor_uri&&(d.cursor_uri=!1),Util.Warn("Data URI scheme cursor not supported")),e.style.cursor=r}catch(o){Util.Error("Data URI scheme cursor test exception: "+o),d.cursor_uri=!1}return Util.Debug("<< Display.constructor"),s}var a,r,i,o,n,s={},d={},c=null,l=0,u=0,f={x:0,y:0,w:0,h:0},p={x1:0,y1:0,x2:-1,y2:-1},_="",h=null,m=null,v=0,$=0;return Util.conf_defaults(d,s,e,[["target","wo","dom",null,"Canvas element for rendering"],["context","ro","raw",null,"Canvas 2D context for rendering (read-only)"],["logo","rw","raw",null,'Logo to display when cleared: {"width": width, "height": height, "data": data}'],["true_color","rw","bool",!0,"Use true-color pixel data"],["colourMap","rw","arr",[],"Colour map array (when not true-color)"],["scale","rw","float",1,"Display area scale factor 0.0 - 1.0"],["viewport","rw","bool",!1,"Use a viewport set with viewportChange()"],["width","rw","int",null,"Display area width"],["height","rw","int",null,"Display area height"],["render_mode","ro","str","","Canvas rendering mode (read-only)"],["prefer_js","rw","str",null,"Prefer Javascript over canvas methods"],["cursor_uri","rw","raw",null,"Can we render cursor using data URI"]]),s.get_context=function(){return c},s.set_scale=function(e){n(e)},s.set_width=function(e){s.resize(e,u)},s.get_width=function(){return l},s.set_height=function(e){s.resize(l,e)},s.get_height=function(){return u},n=function(e){var t,a,r,i,o=["transform","WebkitTransform","MozTransform",null];for(t=d.target,a=o.shift();a&&"undefined"==typeof t.style[a];)a=o.shift();return null===a?(Util.Debug("No scaling support"),void 0):("undefined"==typeof e?e=d.scale:e>1?e=1:.1>e&&(e=.1),d.scale!==e&&(d.scale=e,r=t.width-t.width*e,i=t.height-t.height*e,t.style[a]="scale("+d.scale+") translate(-"+r+"px, -"+i+"px)"),void 0)},o=function(e){var t,a;t=d.true_color?e:d.colourMap[e[0]],a="rgb("+t[2]+","+t[1]+","+t[0]+")",a!==_&&(c.fillStyle=a,_=a)},s.viewportChange=function(e,t,a,r){var i,o,n,s,_,h,m,v=d.target,$=f,g=p,b=null;d.viewport||(Util.Debug("Setting viewport to full display region"),e=-$.w,t=-$.h,a=l,r=u),"undefined"==typeof e&&(e=0),"undefined"==typeof t&&(t=0),"undefined"==typeof a&&(a=$.w),"undefined"==typeof r&&(r=$.h),a>l&&(a=l),r>u&&(r=u),($.w!==a||$.h!==r)&&(a<$.w&&g.x2>$.x+a-1&&(g.x2=$.x+a-1),$.w=a,r<$.h&&g.y2>$.y+r-1&&(g.y2=$.y+r-1),$.h=r,$.w>0&&$.h>0&&v.width>0&&v.height>0&&(b=c.getImageData(0,0,v.width<$.w?v.width:$.w,v.height<$.h?v.height:$.h)),v.width=$.w,v.height=$.h,b&&c.putImageData(b,0,0)),s=$.x+$.w-1,_=$.y+$.h-1,0>e&&$.x+e<0&&(e=-$.x),s+e>=l&&(e-=s+e-l+1),$.y+t<0&&(t=-$.y),_+t>=u&&(t-=_+t-u+1),(0!==e||0!==t)&&(Util.Debug("viewportChange deltaX: "+e+", deltaY: "+t),$.x+=e,s+=e,$.y+=t,_+=t,$.x>g.x1&&(g.x1=$.x),s<g.x2&&(g.x2=s),$.y>g.y1&&(g.y1=$.y),_<g.y2&&(g.y2=_),0>e?(o=0,h=-e):(o=$.w-e,h=e),0>t?(n=0,m=-t):(n=$.h-t,m=t),i=c.fillStyle,c.fillStyle="rgb(255,255,255)",0!==e&&(c.drawImage(v,0,0,$.w,$.h,-e,0,$.w,$.h),c.fillRect(o,0,h,$.h)),0!==t&&(c.drawImage(v,0,0,$.w,$.h,0,-t,$.w,$.h),c.fillRect(0,n,$.w,m)),c.fillStyle=i)},s.getCleanDirtyReset=function(){var e,t=f,a=p,r=[],i=t.x+t.w-1,o=t.y+t.h-1;return e={x:a.x1,y:a.y1,w:a.x2-a.x1+1,h:a.y2-a.y1+1},a.x1>=a.x2||a.y1>=a.y2?r.push({x:t.x,y:t.y,w:t.w,h:t.h}):(t.x<a.x1&&r.push({x:t.x,y:t.y,w:a.x1-t.x+1,h:t.h}),i>a.x2&&r.push({x:a.x2+1,y:t.y,w:i-a.x2,h:t.h}),t.y<a.y1&&r.push({x:a.x1,y:t.y,w:a.x2-a.x1+1,h:a.y1-t.y}),o>a.y2&&r.push({x:a.x1,y:a.y2+1,w:a.x2-a.x1+1,h:o-a.y2})),p={x1:t.x,y1:t.y,x2:t.x+t.w-1,y2:t.y+t.h-1},{cleanBox:e,dirtyBoxes:r}},s.absX=function(e){return e+f.x},s.absY=function(e){return e+f.y},s.resize=function(e,t){_="",l=e,u=t,n(d.scale),s.viewportChange()},s.clear=function(){d.logo?(s.resize(d.logo.width,d.logo.height),s.blitStringImage(d.logo.data,0,0)):(s.resize(640,20),c.clearRect(0,0,f.w,f.h))},s.fillRect=function(e,t,a,r,i){o(i),c.fillRect(e-f.x,t-f.y,a,r)},s.copyImage=function(e,t,a,r,i,o){var n=e-f.x,s=t-f.y,l=a-f.x,u=r-f.y;c.drawImage(d.target,n,s,i,o,l,u,i,o)},s.startTile=function(e,t,a,r,i){var o,n,l,u,f,p;if(v=e,$=t,h=16===a&&16===r?m:c.createImageData(a,r),o=h.data,d.prefer_js)for(n=d.true_color?i:d.colourMap[i[0]],l=n[2],u=n[1],f=n[0],p=0;a*r*4>p;p+=4)o[p]=l,o[p+1]=u,o[p+2]=f,o[p+3]=255;else s.fillRect(e,t,a,r,i)},s.subTile=function(e,t,a,r,i){var o,n,c,l,u,f,p,_,m,g,b;if(d.prefer_js)for(o=h.data,p=h.width,c=d.true_color?i:d.colourMap[i[0]],l=c[2],u=c[1],f=c[0],g=e+a,b=t+r,_=t;b>_;_+=1)for(m=e;g>m;m+=1)n=4*(m+_*p),o[n]=l,o[n+1]=u,o[n+2]=f,o[n+3]=255;else s.fillRect(v+e,$+t,a,r,i)},s.finishTile=function(){d.prefer_js&&c.putImageData(h,v-f.x,$-f.y)},a=function(e,t,a,r,i,o){var n,s,d,l,u=f;for(n=c.createImageData(a,r),l=n.data,s=0,d=o;a*r*4>s;s+=4,d+=3)l[s]=i[d],l[s+1]=i[d+1],l[s+2]=i[d+2],l[s+3]=255;c.putImageData(n,e-u.x,t-u.y)},r=function(e,t,a,r,i,o){var n,s,d,l,u=f;for(n=c.createImageData(a,r),l=n.data,s=0,d=o;a*r*4>s;s+=4,d+=4)l[s]=i[d+2],l[s+1]=i[d+1],l[s+2]=i[d],l[s+3]=255;c.putImageData(n,e-u.x,t-u.y)},i=function(e,t,a,r,i,o){var n,s,l,u,p,_;for(n=c.createImageData(a,r),u=n.data,_=d.colourMap,s=0,l=o;a*r*4>s;s+=4,l+=1)p=_[i[l]],u[s]=p[2],u[s+1]=p[1],u[s+2]=p[0],u[s+3]=255;c.putImageData(n,e-f.x,t-f.y)},s.blitImage=function(e,t,a,o,n,s){d.true_color?r(e,t,a,o,n,s):i(e,t,a,o,n,s)},s.blitRgbImage=function(e,t,r,o,n,s){d.true_color?a(e,t,r,o,n,s):i(e,t,r,o,n,s)},s.blitStringImage=function(e,t,a){var r=new Image;r.onload=function(){c.drawImage(r,t-f.x,a-f.y)},r.src=e},s.changeCursor=function(e,t,a,r,i,o){return d.cursor_uri===!1?(Util.Warn("changeCursor called but no cursor data URI support"),void 0):(d.true_color?changeCursor(d.target,e,t,a,r,i,o):changeCursor(d.target,e,t,a,r,i,o,d.colourMap),void 0)},s.defaultCursor=function(){d.target.style.cursor="default"},t()}function changeCursor(e,t,a,r,i,o,n,s){"use strict";var d,c,l,u,f,p,_,h,m,v,$=[];for($.push16le=function(e){this.push(255&e,e>>8&255)},$.push32le=function(e){this.push(255&e,e>>8&255,e>>16&255,e>>24&255)},c=40,l=o*n*4,f=Math.ceil(o*n/8),u=Math.ceil(o*n/8),$.push16le(0),$.push16le(2),$.push16le(1),$.push(o),$.push(n),$.push(0),$.push(0),$.push16le(r),$.push16le(i),$.push32le(c+l+f+u),$.push32le(22),$.push32le(c),$.push32le(o),$.push32le(2*n),$.push16le(1),$.push16le(32),$.push32le(0),$.push32le(f+u),$.push32le(0),$.push32le(0),$.push32le(0),$.push32le(0),v=n-1;v>=0;v-=1)for(m=0;o>m;m+=1)_=v*Math.ceil(o/8)+Math.floor(m/8),h=a[_]<<m%8&128?255:0,s?(_=o*v+m,d=s[t[_]],$.push(d[2]),$.push(d[1]),$.push(d[0]),$.push(h)):(_=4*(o*v+m),$.push(t[_+2]),$.push(t[_+1]),$.push(t[_]),$.push(h));for(v=0;n>v;v+=1)for(m=0;m<Math.ceil(o/8);m+=1)$.push(0);for(v=0;n>v;v+=1)for(m=0;m<Math.ceil(o/8);m+=1)$.push(0);p="data:image/x-icon;base64,"+Base64.encode($),e.style.cursor="url("+p+") "+r+" "+i+", default"}