/*
 * noVNC: HTML5 VNC client
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * See README.md for usage and integration instructions.
 *
 * TIGHT decoder portion:
 * (c) 2012 Michael Tinglof, Joe Balaz, Les Piech (Mercuri.ca)
 */
function RFB(e){"use strict";function t(){var e,t;for(Util.Debug(">> RFB.constructor"),e=0;e<G.length;e+=1)H[G[e][1]]=H[G[e][0]],L[G[e][1]]=G[e][0],j[G[e][1]]=[0,0];try{N=new Display({target:Q.target})}catch(i){Util.Error("Display exception: "+i),s("fatal","No working Display")}return z=new Keyboard({target:Q.focusContainer,onKeyPress:E}),K=new Mouse({target:Q.target,onMouseButton:C,onMouseMove:I}),t=N.get_render_mode(),F=new Websock,F.on("message",d),F.on("open",function(){"connect"===M?s("ProtocolVersion","Starting VNC handshake"):c("Got unexpected WebSockets connection")}),F.on("close",function(e){e.code&&Util.Info("Close code: "+e.code+", reason: "+e.reason+", wasClean: "+e.wasClean),"disconnect"===M?s("disconnected","VNC disconnected"):"ProtocolVersion"===M?c("Failed to connect to server"):M in{failed:1,disconnected:1}?Util.Error("Received onclose while disconnected"):c("Server disconnected")}),F.on("error",function(e){c("WebSock error: "+e)}),o(),Websock_native?(Util.Info("Using native WebSockets"),s("loaded","noVNC ready: native WebSockets, "+t)):(Util.Warn("Using web-socket-js bridge. Flash version: "+Util.Flash.version),!Util.Flash||Util.Flash.version<9?s("fatal","WebSockets or <a href='http://get.adobe.com/flashplayer'>Adobe Flash</a> is required"):"file://"===document.location.href.substr(0,7)?s("fatal","'file://' URL is incompatible with Adobe Flash"):s("loaded","noVNC ready: WebSockets emulation, "+t)),Util.Debug("<< RFB.constructor"),x}function i(){Util.Debug(">> RFB.connect");var e;"undefined"!=typeof UsingSocketIO?e="http://"+B+":"+$+"/"+S:(e=Q.encrypt?"wss://":"ws://",e+=B+":"+$+"/"+S),Util.Info("connecting to "+e),F.open(e),Util.Debug("<< RFB.connect")}function r(e,t){var i,r=[];for(i=0;i<e.length;i+=1)r.push(e.charCodeAt(i));return new DES(r).encrypt(t)}function n(){return dt.length>0?(F.send(dt),setTimeout(function(){F.send(g())},50),dt=[],!0):!1}function a(e){1===X&&c("Tight protocol handler only implements true color mode");var t,i,r,n,a,o,s=-1,d=0,l=-1,u=F.get_rQ(),f=F.get_rQi();if(O.bytes=1,F.rQwait("TIGHT compression-control",O.bytes))return!1;var h=function(e){for(var t=0;4>t;t++)d>>t&1&&(O.zlibs[t].reset(),Util.Info("Reset zlib stream "+t));var i=O.zlibs[l].uncompress(e,0);return 0!==i.status&&Util.Error("Invalid data in zlib stream"),i.data},p=function(){var e=u[f+2]+1,t=e*X;if(O.bytes+=t,F.rQwait("TIGHT palette "+i,O.bytes))return!1;var n=2>=e?1:8,a=Math.floor((O.width*n+7)/8),s=!1;if(a*O.height<12?(s=!0,r=[0,a*O.height]):r=y(F.rQslice(3+t,3+t+3)),O.bytes+=r[0]+r[1],F.rQwait("TIGHT "+i,O.bytes))return!1;F.rQshiftBytes(3);var c=F.rQshiftBytes(t);F.rQshiftBytes(r[0]),o=s?F.rQshiftBytes(r[1]):h(F.rQshiftBytes(r[1]));var d,l,p,m,v,g,_,b=[];if(2===e)for(m=Math.floor((O.width+7)/8),v=Math.floor(O.width/8),l=0;l<O.height;l++){for(d=0;v>d;d++)for(p=7;p>=0;p--)g=3*(l*O.width+8*d+7-p),_=3*(o[l*m+d]>>p&1),b[g]=c[_],b[g+1]=c[_+1],b[g+2]=c[_+2];for(p=7;p>=8-O.width%8;p--)g=3*(l*O.width+8*d+7-p),_=3*(o[l*m+d]>>p&1),b[g]=c[_],b[g+1]=c[_+1],b[g+2]=c[_+2]}else for(l=0;l<O.height;l++)for(d=0;d<O.width;d++)g=3*(l*O.width+d),_=3*o[l*O.width+d],b[g]=c[_],b[g+1]=c[_+1],b[g+2]=c[_+2];return O.imgQ.push({type:"rgb",img:{complete:!0,data:b},x:O.x,y:O.y,width:O.width,height:O.height}),!0},m=function(){var e=!1,t=O.width*O.height*X;return 12>t?(e=!0,r=[0,t]):r=y(F.rQslice(1,4)),O.bytes=1+r[0]+r[1],F.rQwait("TIGHT "+i,O.bytes)?!1:(F.rQshiftBytes(1+r[0]),o=e?F.rQshiftBytes(r[1]):h(F.rQshiftBytes(r[1])),O.imgQ.push({type:"rgb",img:{complete:!0,data:o},x:O.x,y:O.y,width:O.width,height:O.height}),!0)};if(t=F.rQpeek8(),d=15&t,t>>=4,l=3&t,8===t)i="fill";else if(9===t)i="jpeg";else if(10===t)i="png";else if(4&t)i="filter";else{if(!(4>t))throw"Illegal tight compression received, ctl: "+t;i="copy"}if(e&&("filter"===i||"copy"===i))throw"filter/copy received in tightPNG mode";switch(i){case"fill":O.bytes+=X;break;case"jpeg":O.bytes+=3;break;case"png":O.bytes+=3;break;case"filter":O.bytes+=2;break;case"copy":}if(F.rQwait("TIGHT "+i,O.bytes))return!1;switch(i){case"fill":F.rQshift8(),n=F.rQshiftBytes(X),O.imgQ.push({type:"fill",img:{complete:!0},x:O.x,y:O.y,width:O.width,height:O.height,color:[n[2],n[1],n[0]]});break;case"png":case"jpeg":if(r=y(F.rQslice(1,4)),O.bytes=1+r[0]+r[1],F.rQwait("TIGHT "+i,O.bytes))return!1;F.rQshiftBytes(1+r[0]),a=new Image,O.imgQ.push({type:"img",img:a,x:O.x,y:O.y}),a.src="data:image/"+i+w(F.rQshiftBytes(r[1])),a=null;break;case"filter":if(s=u[f+1],1!==s)throw"Unsupported tight subencoding received, filter: "+s;if(!p())return!1;break;case"copy":if(!m())return!1}return O.bytes=0,O.rects-=1,!0}var o,s,c,d,l,u,f,h,p,m,v,g,_,b,A,y,w,k,E,C,I,D,x={},Q={},B="",$=5900,R="",S="",M="disconnected",U=0,T=3.8,P="",G=[["COPYRECT",1],["TIGHT",7],["TIGHT_PNG",-260],["HEXTILE",5],["RRE",2],["RAW",0],["DesktopSize",-223],["Cursor",-239],["JPEG_quality_med",-26],["compress_hi",-247],["last_rect",-224]],H={},L={},j={},F=null,N=null,z=null,K=null,V=null,q=null,Y=null,Z=null,O={rects:0,subrects:0,lines:0,tiles:0,bytes:0,x:0,y:0,width:0,height:0,encoding:0,subencoding:-1,background:null,imgQ:[],zlibs:[]},W=4,X=3,J=0,et=0,tt="",it=40,rt=0,nt=100,at={last_fbu:0,fbu_total:0,fbu_total_cnt:0,full_fbu_total:0,full_fbu_cnt:0,fbu_rt_start:0,fbu_rt_total:0,fbu_rt_cnt:0,pixels:0},ot=!1,st=Websock_native?10:25,ct=0,dt=[],lt=!1,ut={};return Util.conf_defaults(Q,x,e,[["target","wo","dom",null,"VNC display rendering Canvas object"],["focusContainer","wo","dom",document,"DOM element that captures keyboard input"],["encrypt","rw","bool",!1,"Use TLS/SSL/wss encryption"],["true_color","rw","bool",!0,"Request true color pixel data"],["local_cursor","rw","bool",!1,"Request locally rendered cursor"],["shared","rw","bool",!0,"Request shared mode"],["view_only","rw","bool",!1,"Disable client mouse/keyboard"],["connectTimeout","rw","int",st,"Time (s) to wait for connection"],["disconnectTimeout","rw","int",10,"Time (s) to wait for disconnection"],["viewportDrag","rw","bool",!1,"Move the viewport on mouse drags"],["check_rate","rw","int",217,"Timing (ms) of send/receive check"],["fbu_req_rate","rw","int",1413,"Timing (ms) of frameBufferUpdate requests"],["onUpdateState","rw","func",function(){},"onUpdateState(rfb, state, oldstate, statusMsg): RFB state update/change "],["onPasswordRequired","rw","func",function(){},"onPasswordRequired(rfb): VNC password is required "],["onClipboard","rw","func",function(){},"onClipboard(rfb, text): RFB clipboard contents received"],["onBell","rw","func",function(){},"onBell(rfb): RFB Bell message received "],["onFBUReceive","rw","func",function(){},"onFBUReceive(rfb, fbu): RFB FBU received but not yet processed "],["onFBUComplete","rw","func",function(){},"onFBUComplete(rfb, fbu): RFB FBU received and processed "],["updateState","rw","func",function(){},"obsolete, use onUpdateState"],["clipboardReceive","rw","func",function(){},"obsolete, use onClipboard"]]),x.set_local_cursor=function(e){!e||e in{0:1,no:1,"false":1}?Q.local_cursor=!1:N.get_cursor_uri()?Q.local_cursor=!0:Util.Warn("Browser does not support local cursor")},x.get_display=function(){return N},x.get_keyboard=function(){return z},x.get_mouse=function(){return K},o=function(){var e;for(F.init(),O.rects=0,O.subrects=0,O.lines=0,O.tiles=0,O.imgQ=[],O.zlibs=[],ct=0,dt=[],e=0;e<G.length;e+=1)j[G[e][1]][0]=0;for(e=0;4>e;e++)O.zlibs[e]=new TINF,O.zlibs[e].init()},h=function(){var e,t;for(Util.Info("Encoding stats for this connection:"),e=0;e<G.length;e+=1)t=j[G[e][1]],t[0]+t[1]>0&&Util.Info("    "+G[e][0]+": "+t[0]+" rects");for(Util.Info("Encoding stats since page load:"),e=0;e<G.length;e+=1)t=j[G[e][1]],t[0]+t[1]>0&&Util.Info("    "+G[e][0]+": "+t[1]+" rects")},s=function(e,t){var r,n,a=M;if(e===a)return Util.Debug("Already in state '"+e+"', ignoring."),void 0;switch(e in{disconnected:1,loaded:1,connect:1,disconnect:1,failed:1,fatal:1}&&(V&&(clearInterval(V),V=null),Z&&(clearInterval(Z),Z=null),N&&N.get_context()&&(z.ungrab(),K.ungrab(),N.defaultCursor(),("debug"!==Util.get_logging()||"loaded"===e)&&N.clear()),F.close()),"fatal"===a&&Util.Error("Fatal error, cannot continue"),r="failed"===e||"fatal"===e?Util.Error:Util.Warn,M="failed"===a&&"disconnected"===e?"failed":e,n="undefined"!=typeof t?" Msg: "+t:"",r("New state '"+M+"', was '"+a+"'."+n),q&&"connect"!==M&&(Util.Debug("Clearing connect timer"),clearInterval(q),q=null),Y&&"disconnect"!==M&&(Util.Debug("Clearing disconnect timer"),clearInterval(Y),Y=null),e){case"normal":("disconnected"===a||"failed"===a)&&Util.Error("Invalid transition from 'disconnected' or 'failed' to 'normal'");break;case"connect":q=setTimeout(function(){c("Connect timeout")},1e3*Q.connectTimeout),o(),i();break;case"disconnect":ot||(Y=setTimeout(function(){c("Disconnect timeout")},1e3*Q.disconnectTimeout)),h();break;case"failed":"disconnected"===a&&Util.Error("Invalid transition from 'disconnected' to 'failed'"),"normal"===a&&Util.Error("Error while connected."),"init"===a&&Util.Error("Error while initializing."),setTimeout(function(){s("disconnected")},50)}"failed"===a&&"disconnected"===e?(Q.updateState(x,e,a),Q.onUpdateState(x,e,a)):(Q.updateState(x,e,a,t),Q.onUpdateState(x,e,a,t))},c=function(e){return s("failed",e),!1},d=function(){if(0===F.rQlen())return Util.Warn("handle_message called on empty receive queue"),void 0;switch(M){case"disconnected":case"failed":Util.Error("Got data while disconnected");break;case"normal":u()&&F.rQlen()>0&&(null===Z?(Util.Debug("More data to process, creating timer"),Z=setTimeout(function(){Z=null,d()},10)):Util.Debug("More data to process, existing timer"));break;default:l()}},D=function(){var e;"normal"!==M||lt||n()||(e=(new Date).getTime(),e>rt+Q.fbu_req_rate&&(rt=e,F.send(g()))),setTimeout(D,Q.check_rate)},E=function(e,t){var i;Q.view_only||(i=_(e,t),i=i.concat(g()),F.send(i))},C=function(e,t,i,r){if(i?ct|=r:ct^=r,Q.viewportDrag){if(i&&!lt)return lt=!0,ut={x:e,y:t},void 0;lt=!1,F.send(g())}Q.view_only||(dt=dt.concat(b(N.absX(e),N.absY(t))),n())},I=function(e,t){var i,r;return lt?(i=ut.x-e,r=ut.y-t,ut={x:e,y:t},N.viewportChange(i,r),void 0):(Q.view_only||(dt=dt.concat(b(N.absX(e),N.absY(t)))),void 0)},l=function(){var e,t,i,n,a,o,d,u,f,h,v,_,b,A,y,w,E,C,I,B,$;switch(M){case"ProtocolVersion":if(F.rQlen()<12)return c("Incomplete protocol version");switch(n=F.rQshiftStr(12).substr(4,7),Util.Info("Server ProtocolVersion: "+n),n){case"003.003":U=3.3;break;case"003.006":U=3.3;break;case"003.007":U=3.7;break;case"003.008":U=3.8;break;case"004.000":U=3.8;break;default:return c("Invalid server version "+n)}U>T&&(U=T),ot||(V=setInterval(function(){F.flush()},50)),a="00"+parseInt(U,10)+".00"+10*U%10,F.send_string("RFB "+a+"\n"),s("Security","Sent ProtocolVersion: "+a);break;case"Security":if(U>=3.7){if(u=F.rQshift8(),F.rQwait("security type",u,1))return!1;if(0===u)return e=F.rQshift32(),t=F.rQshiftStr(e),c("Security failure: "+t);for(P=0,d=F.rQshiftBytes(u),Util.Debug("Server security types: "+d),o=0;o<d.length;o+=1)d[o]>P&&d[o]<3&&(P=d[o]);if(0===P)return c("Unsupported security types: "+d);F.send([P])}else{if(F.rQwait("security scheme",4))return!1;P=F.rQshift32()}s("Authentication","Authenticating using scheme: "+P),l();break;case"Authentication":switch(P){case 0:return F.rQwait("auth reason",4)?!1:(e=F.rQshift32(),t=F.rQshiftStr(e),c("Auth failure: "+t));case 1:if(U>=3.8)return s("SecurityResult"),void 0;break;case 2:return 0===R.length?(s("password","Password Required"),Q.onPasswordRequired(x),void 0):F.rQwait("auth challenge",16)?!1:(f=F.rQshiftBytes(16),h=r(R,f),F.send(h),s("SecurityResult"),void 0);default:return c("Unsupported auth scheme: "+P),void 0}s("ClientInitialisation","No auth required"),l();break;case"SecurityResult":if(F.rQwait("VNC auth response ",4))return!1;switch(F.rQshift32()){case 0:break;case 1:if(U>=3.8){if(i=F.rQshift32(),F.rQwait("SecurityResult reason",i,8))return!1;t=F.rQshiftStr(i),c(t)}else c("Authentication failed");return;case 2:return c("Too many auth attempts")}s("ClientInitialisation","Authentication OK"),l();break;case"ClientInitialisation":F.send([Q.shared?1:0]),s("ServerInitialisation","Authentication OK");break;case"ServerInitialisation":if(F.rQwait("server initialization",24))return!1;J=F.rQshift16(),et=F.rQshift16(),v=F.rQshift8(),_=F.rQshift8(),b=F.rQshift8(),B=F.rQshift8(),A=F.rQshift16(),y=F.rQshift16(),w=F.rQshift16(),E=F.rQshift8(),C=F.rQshift8(),I=F.rQshift8(),F.rQshiftStr(3),Util.Info("Screen: "+J+"x"+et+", bpp: "+v+", depth: "+_+", big_endian: "+b+", true_color: "+B+", red_max: "+A+", green_max: "+y+", blue_max: "+w+", red_shift: "+E+", green_shift: "+C+", blue_shift: "+I),0!==b&&Util.Warn("Server native endian is not little endian"),16!==E&&Util.Warn("Server native red-shift is not 16"),0!==I&&Util.Warn("Server native blue-shift is not 0"),$=F.rQshift32(),tt=F.rQshiftStr($),Q.true_color&&"Intel(r) AMT KVM"===tt&&(Util.Warn("Intel AMT KVM only support 8/16 bit depths. Disabling true color"),Q.true_color=!1),N.set_true_color(Q.true_color),N.resize(J,et),z.grab(),K.grab(),Q.true_color?(W=4,X=3):(W=1,X=1),h=p(),h=h.concat(m()),h=h.concat(g()),at.fbu_rt_start=(new Date).getTime(),F.send(h),setTimeout(D,Q.check_rate),setTimeout(k,it),Q.encrypt?s("normal","Connected (encrypted) to: "+tt):s("normal","Connected (unencrypted) to: "+tt)}},u=function(){var e,t,i,r,n,a,o,s,d,l=!0;switch(e=O.rects>0?0:F.rQshift8()){case 0:l=f();break;case 1:if(Util.Debug("SetColourMapEntries"),F.rQshift8(),n=F.rQshift16(),a=F.rQshift16(),F.rQwait("SetColourMapEntries",6*a,6))return!1;for(r=0;a>r;r+=1)o=F.rQshift16(),o=parseInt(o/256,10),s=parseInt(F.rQshift16()/256,10),d=parseInt(F.rQshift16()/256,10),N.set_colourMap([d,s,o],n+r);Util.Debug("colourMap: "+N.get_colourMap()),Util.Info("Registered "+a+" colourMap entries");break;case 2:Util.Debug("Bell"),Q.onBell(x);break;case 3:if(Util.Debug("ServerCutText"),F.rQwait("ServerCutText header",7,1))return!1;if(F.rQshiftBytes(3),t=F.rQshift32(),F.rQwait("ServerCutText",t,8))return!1;i=F.rQshiftStr(t),Q.clipboardReceive(x,i),Q.onClipboard(x,i);break;default:c("Disconnected: illegal server message type "+e),Util.Debug("ws.rQslice(0,30):"+F.rQslice(0,30))}return l},f=function(){var e,t,i,r=!0;if(0===O.rects){if(F.rQwait("FBU header",3))return F.rQunshift8(0),!1;F.rQshift8(),O.rects=F.rQshift16(),O.bytes=0,at.cur_fbu=0,at.fbu_rt_start>0&&(e=(new Date).getTime(),Util.Info("First FBU latency: "+(e-at.fbu_rt_start)))}for(;O.rects>0;){if("normal"!==M)return!1;if(F.rQwait("FBU",O.bytes))return!1;if(0===O.bytes){if(F.rQwait("rect header",12))return!1;if(t=F.rQshiftBytes(12),O.x=(t[0]<<8)+t[1],O.y=(t[2]<<8)+t[3],O.width=(t[4]<<8)+t[5],O.height=(t[6]<<8)+t[7],O.encoding=parseInt((t[8]<<24)+(t[9]<<16)+(t[10]<<8)+t[11],10),Q.onFBUReceive(x,{x:O.x,y:O.y,width:O.width,height:O.height,encoding:O.encoding,encodingName:L[O.encoding]}),!L[O.encoding])return c("Disconnected: unsupported encoding "+O.encoding),!1}if(at.last_fbu=(new Date).getTime(),r=H[O.encoding](),e=(new Date).getTime(),at.cur_fbu+=e-at.last_fbu,r&&(j[O.encoding][0]+=1,j[O.encoding][1]+=1,at.pixels+=O.width*O.height),(0===O.rects||at.pixels>=J*et)&&((O.width===J&&O.height===et||at.fbu_rt_start>0)&&(at.full_fbu_total+=at.cur_fbu,at.full_fbu_cnt+=1,Util.Info("Timing of full FBU, cur: "+at.cur_fbu+", total: "+at.full_fbu_total+", cnt: "+at.full_fbu_cnt+", avg: "+at.full_fbu_total/at.full_fbu_cnt)),at.fbu_rt_start>0&&(i=e-at.fbu_rt_start,at.fbu_rt_total+=i,at.fbu_rt_cnt+=1,Util.Info("full FBU round-trip, cur: "+i+", total: "+at.fbu_rt_total+", cnt: "+at.fbu_rt_cnt+", avg: "+at.fbu_rt_total/at.fbu_rt_cnt),at.fbu_rt_start=0)),!r)return r}return Q.onFBUComplete(x,{x:O.x,y:O.y,width:O.width,height:O.height,encoding:O.encoding,encodingName:L[O.encoding]}),!0},H.RAW=function(){var e,t;return 0===O.lines&&(O.lines=O.height),O.bytes=O.width*W,F.rQwait("RAW",O.bytes)?!1:(e=O.y+(O.height-O.lines),t=Math.min(O.lines,Math.floor(F.rQlen()/(O.width*W))),N.blitImage(O.x,e,O.width,t,F.get_rQ(),F.get_rQi()),F.rQshiftBytes(O.width*t*W),O.lines-=t,O.lines>0?O.bytes=O.width*W:(O.rects-=1,O.bytes=0),!0)},H.COPYRECT=function(){var e,t;return F.rQwait("COPYRECT",4)?!1:(e=F.rQshift16(),t=F.rQshift16(),N.copyImage(e,t,O.x,O.y,O.width,O.height),O.rects-=1,O.bytes=0,!0)},H.RRE=function(){var e,t,i,r,n,a;if(0===O.subrects){if(F.rQwait("RRE",4+W))return!1;O.subrects=F.rQshift32(),e=F.rQshiftBytes(W),N.fillRect(O.x,O.y,O.width,O.height,e)}for(;O.subrects>0&&F.rQlen()>=W+8;)e=F.rQshiftBytes(W),t=F.rQshift16(),i=F.rQshift16(),r=F.rQshift16(),n=F.rQshift16(),N.fillRect(O.x+t,O.y+i,r,n,e),O.subrects-=1;return O.subrects>0?(a=Math.min(nt,O.subrects),O.bytes=(W+8)*a):(O.rects-=1,O.bytes=0),!0},H.HEXTILE=function(){var e,t,i,r,n,a,o,s,d,l,u,f,h,p,m,v,g,_=F.get_rQ(),b=F.get_rQi();for(0===O.tiles&&(O.tiles_x=Math.ceil(O.width/16),O.tiles_y=Math.ceil(O.height/16),O.total_tiles=O.tiles_x*O.tiles_y,O.tiles=O.total_tiles);O.tiles>0;){if(O.bytes=1,F.rQwait("HEXTILE subencoding",O.bytes))return!1;if(e=_[b],e>30)return c("Disconnected: illegal hextile subencoding "+e),!1;if(t=0,r=O.total_tiles-O.tiles,n=r%O.tiles_x,s=Math.floor(r/O.tiles_x),a=O.x+16*n,d=O.y+16*s,o=Math.min(16,O.x+O.width-a),l=Math.min(16,O.y+O.height-d),1&e)O.bytes+=o*l*W;else if(2&e&&(O.bytes+=W),4&e&&(O.bytes+=W),8&e){if(O.bytes+=1,F.rQwait("hextile subrects header",O.bytes))return!1;t=_[b+O.bytes-1],O.bytes+=16&e?t*(W+2):2*t}if(F.rQwait("hextile",O.bytes))return!1;if(O.subencoding=_[b],b+=1,0===O.subencoding)1&O.lastsubencoding?Util.Debug("     Ignoring blank after RAW"):N.fillRect(a,d,o,l,O.background);else if(1&O.subencoding)N.blitImage(a,d,o,l,_,b),b+=O.bytes-1;else{if(2&O.subencoding&&(O.background=_.slice(b,b+W),b+=W),4&O.subencoding&&(O.foreground=_.slice(b,b+W),b+=W),N.startTile(a,d,o,l,O.background),8&O.subencoding)for(t=_[b],b+=1,f=0;t>f;f+=1)16&O.subencoding?(i=_.slice(b,b+W),b+=W):i=O.foreground,u=_[b],b+=1,h=u>>4,p=15&u,m=_[b],b+=1,v=(m>>4)+1,g=(15&m)+1,N.subTile(h,p,v,g,i);N.finishTile()}F.set_rQi(b),O.lastsubencoding=O.subencoding,O.bytes=0,O.tiles-=1}return 0===O.tiles&&(O.rects-=1),!0},y=function(e){var t=1,i=0;return i+=127&e[0],128&e[0]&&(t+=1,i+=(127&e[1])<<7,128&e[1]&&(t+=1,i+=e[2]<<14)),[t,i]},w=function(e){return";base64,"+Base64.encode(e)},k=function(){var e,t,i;if(i=N.get_context(),"normal"===M){for(t=O.imgQ;t.length>0&&t[0].img.complete;)e=t.shift(),"fill"===e.type?N.fillRect(e.x,e.y,e.width,e.height,e.color):"rgb"===e.type?N.blitRgbImage(e.x,e.y,e.width,e.height,e.img.data,0):i.drawImage(e.img,e.x,e.y);setTimeout(k,it)}},H.TIGHT=function(){return a(!1)},H.TIGHT_PNG=function(){return a(!0)},H.last_rect=function(){return Util.Debug(">> set_desktopsize"),O.rects=0,Util.Debug("<< set_desktopsize"),!0},H.DesktopSize=function(){return Util.Debug(">> set_desktopsize"),J=O.width,et=O.height,N.resize(J,et),at.fbu_rt_start=(new Date).getTime(),F.send(g()),O.bytes=0,O.rects-=1,Util.Debug("<< set_desktopsize"),!0},H.Cursor=function(){var e,t,i,r,n,a;return e=O.x,t=O.y,i=O.width,r=O.height,n=i*r*W,a=Math.floor((i+7)/8)*r,O.bytes=n+a,F.rQwait("cursor encoding",O.bytes)?!1:(N.changeCursor(F.rQshiftBytes(n),F.rQshiftBytes(a),e,t,i,r),O.bytes=0,O.rects-=1,!0)},H.JPEG_quality_lo=function(){Util.Error("Server sent jpeg_quality pseudo-encoding")},H.compress_lo=function(){Util.Error("Server sent compress level pseudo-encoding")},p=function(){var e;return e=[0],e.push8(0),e.push8(0),e.push8(0),e.push8(8*W),e.push8(8*X),e.push8(0),e.push8(Q.true_color?1:0),e.push16(255),e.push16(255),e.push16(255),e.push8(16),e.push8(8),e.push8(0),e.push8(0),e.push8(0),e.push8(0),e},m=function(){var e,t,i=[];for(t=0;t<G.length;t+=1)"Cursor"!==G[t][0]||Q.local_cursor?i.push(G[t][1]):Util.Debug("Skipping Cursor pseudo-encoding");for(e=[2],e.push8(0),e.push16(i.length),t=0;t<i.length;t+=1)e.push32(i[t]);return e},v=function(e,t,i,r,n){"undefined"==typeof t&&(t=0),"undefined"==typeof i&&(i=0),"undefined"==typeof r&&(r=J),"undefined"==typeof n&&(n=et);var a;return a=[3],a.push8(e),a.push16(t),a.push16(i),a.push16(r),a.push16(n),a},g=function(){var e,t,i,r=N.getCleanDirtyReset(),n=[];for(t=r.cleanBox,t.w>0&&t.h>0&&(n=n.concat(v(1,t.x,t.y,t.w,t.h))),e=0;e<r.dirtyBoxes.length;e++)i=r.dirtyBoxes[e],n=n.concat(v(0,i.x,i.y,i.w,i.h));return n},_=function(e,t){var i;return i=[4],i.push8(t),i.push16(0),i.push32(e),i},b=function(e,t){var i;return i=[5],i.push8(ct),i.push16(e),i.push16(t),i},A=function(e){var t,i,r;for(t=[6],t.push8(0),t.push8(0),t.push8(0),t.push32(e.length),r=e.length,i=0;r>i;i+=1)t.push(e.charCodeAt(i));return t},x.connect=function(e,t,i,r){return B=e,$=t,R=void 0!==i?i:"",S=void 0!==r?r:"",B&&$?(s("connect"),void 0):c("Must set host and port")},x.disconnect=function(){s("disconnect","Disconnecting")},x.sendPassword=function(e){R=e,M="Authentication",setTimeout(l,1)},x.sendCtrlAltDel=function(){if("normal"!==M||Q.view_only)return!1;Util.Info("Sending Ctrl-Alt-Del");var e=[];e=e.concat(_(65507,1)),e=e.concat(_(65513,1)),e=e.concat(_(65535,1)),e=e.concat(_(65535,0)),e=e.concat(_(65513,0)),e=e.concat(_(65507,0)),e=e.concat(g()),F.send(e)},x.sendKey=function(e,t){if("normal"!==M||Q.view_only)return!1;var i=[];"undefined"!=typeof t?(Util.Info("Sending key code ("+(t?"down":"up")+"): "+e),i=i.concat(_(e,t?1:0))):(Util.Info("Sending key code (down + up): "+e),i=i.concat(_(e,1)),i=i.concat(_(e,0))),i=i.concat(g()),F.send(i)},x.clipboardPasteFrom=function(e){"normal"===M&&F.send(A(e))},x.testMode=function(e){ot=!0,x.recv_message=F.testMode(e),D=function(){},x.connect=function(e,t,i){B=e,$=t,R=i,s("ProtocolVersion","Starting VNC handshake")}},t()}